config/routes.rb
Rails.application.routes.draw do
  resources :users
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  get '', to: 'users#index', as: 'default'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/user.rb
class User < ApplicationRecord
  has_secure_password

  validates :firstname, presence: true, blank: false, on: :update
  validates :lastname,  presence: true, blank: false, on: :update
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
    redirect_to edit_user_url unless @user.firstname && @user.lastname
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
    redirect_to @user if @user.firstname && @user.lastname
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: "#{@user.username} was successfully created." }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: "#{@user.username} was successfully updated." }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(
        :username,
        :password,
        :password_confirmation,
        :firstname,
        :lastname
      )
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>TestApp</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body class='reset'>
    <div class='header'>
      <a class='my-company' href='<%= request.base_url %>'>
        <div class='logo'><%= image_tag 'logo.png' %></div>
        <div class='title'>My awesome Company</div>
      </a>
    </div>
    <div class='content'>
      <%= yield %>
    </div>
    <div class='footer'>
      <div class='copyright'>Ngouy 2018</div>
      <div class='blog'>    <a target='_blank' href='https://nathangouy.com'>Blog</a></div>
      <div class='how-am-i'><a target='_blank' href='https://nathangouy.com'>who am I</a></div>
    </div>
  </body>

</html>

app/views/users/_form.html.erb
<%= form_with(model: user, local: true) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :firstname %>
    <%= form.text_field :firstname, id: :user_firstname %>
  </div>

  <div class="field">
    <%= form.label :lastname %>
    <%= form.text_field :lastname, id: :user_lastname, type: :lastname %>
  </div>

  <div class="actions">
    <%= form.submit "Update my informations"%>
  </div>
<% end %>

app/views/users/_sign_up.html.erb
<%= form_with(model: user, local: true) do |form| %>
  <% if user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :username %>
    <%= form.text_field :username, id: :user_username %>
  </div>

  <div class="field">
    <%= form.label :password %>
    <%= form.text_field :password, id: :user_password, type: :password %>
  </div>

  <div class="field">
    <%= form.label :password_confirmation %>
    <%= form.text_field :password_confirmation, id: :user_password_confirmation, type: :password %>
  </div>

  <div class="actions">
    <%= form.submit "Sign up"%>
  </div>
<% end %>

app/views/users/edit.html.erb
<p id="notice"><%= notice %></p>

<%= render 'form', user: @user %>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>
Welcome to this awesome site !
<%= link_to 'New Author (sign up)', new_user_path %>

app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'sign_up', user: @user %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

Your infos are up to date :)